#ifndef _FT_HAL_UTILS_H_
#define _FT_HAL_UTILS_H_


#define RGB(r, g, b)  ((((vc_int32_t)(r)) << 16) | (((vc_int32_t)(g)) << 8) | (b))
#define SQ(v) ((v) * (v))
#define MIN(x,y)  ((x) > (y) ? (y) : (x))
#define MAX(x,y)  ((x) > (y) ? (x) : (y))
#define PLAYCOLOR        0x00A0A080
#define NOTE(n, sharp)   (((n) - 'C') + ((sharp) * 128))
#define F16(s)           ((vc_int32_t)((s) * 65536))
#define INVALID_TOUCH_XY   0x8000
#define ABS(x)  ((x) > (0) ? (x) : (-x))


#endif /* _FT_HAL_UTILS_H_ */






























/*
#include <stdio.h>
#include <Arduino.h>
#include <EEPROM.h>
#include <SPI.h>
#include <avr/pgmspace.h>
*/
/*#include "FT_Platform.h"
#include "FT_Hal_SPI.cpp"
#include "FT_CoPro_Cmds.cpp"
#include "Swiss.cpp"*/

/* Sample application to demonstrat FT800 primitives, widgets and customized screen shots */
#include <Wire.h>
#include <string.h>
#include "FT_Platform.h"
#include "sdcard.h"
#include "FT_Hal_I2C.h"


#define STARTUP_ADDRESS	100*1024L
#define SAMAPP_DELAY_BTW_APIS (1000)
#define SAMAPP_ENABLE_DELAY() Ft_Gpu_Hal_Sleep(SAMAPP_DELAY_BTW_APIS)
#define SAMAPP_ENABLE_DELAY_VALUE(x) Ft_Gpu_Hal_Sleep(x)

#define F16(s)        ((ft_int32_t)((s) * 65536))
#define SQ(v) (v*v)

/* Global variables for display resolution to support various display panels */
/* Default is WQVGA - 480x272 */
#ifdef SAMAPP_DISPLAY_WQVGA
ft_int16_t FT_DispWidth = 480;
ft_int16_t FT_DispHeight = 272;
ft_int16_t FT_DispHCycle =  548;
ft_int16_t FT_DispHOffset = 43;
ft_int16_t FT_DispHSync0 = 0;
ft_int16_t FT_DispHSync1 = 41;
ft_int16_t FT_DispVCycle = 292;
ft_int16_t FT_DispVOffset = 12;
ft_int16_t FT_DispVSync0 = 0;
ft_int16_t FT_DispVSync1 = 10;
ft_uint8_t FT_DispPCLK = 5;
ft_char8_t FT_DispSwizzle = 0;
ft_char8_t FT_DispPCLKPol = 1;
#else
ft_int16_t  FT_DispWidth = 320;
ft_int16_t  FT_DispHeight = 240;
ft_int16_t  FT_DispHCycle =  408;
ft_int16_t  FT_DispHOffset = 70;
ft_int16_t  FT_DispHSync0 = 0;
ft_int16_t  FT_DispHSync1 = 10;
ft_int16_t  FT_DispVCycle = 263;
ft_int16_t  FT_DispVOffset = 13;
ft_int16_t  FT_DispVSync0 = 0;
ft_int16_t  FT_DispVSync1 = 2;
ft_uint8_t  FT_DispPCLK = 8;
ft_char8_t  FT_DispSwizzle = 2;
ft_char8_t  FT_DispPCLKPol = 0;
#endif


struct
{
    ft_uint8_t Hrs;
    ft_uint8_t Mins;
    ft_uint8_t Secs;
    ft_uint8_t date;
    ft_uint8_t month;
    ft_uint8_t year;
    ft_uint16_t mSecs;
}Rtc;



/* Global used for buffer optimization */
Ft_Gpu_Hal_Context_t host,*phost;


ft_uint32_t Ft_CmdBuffer_Index;
ft_uint32_t Ft_DlBuffer_Index;

#ifdef BUFFER_OPTIMIZATION
ft_uint8_t  Ft_DlBuffer[FT_DL_SIZE];
ft_uint8_t  Ft_CmdBuffer[FT_CMD_FIFO_SIZE];
#endif

FT_PROGMEM FT_Gpu_Fonts_t g_Gpu_Fonts[] = {
/* VC1 Hardware Fonts index 28*/
{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,6,8,13,12,15,13,5,7,7,9,12,5,9,6,9,12,12,12,12,12,12,12,12,12,12,5,5,11,12,11,10,19,13,13,13,14,12,12,14,15,6,12,14,12,18,15,14,13,15,13,13,13,14,14,18,13,13,13,6,9,6,9,10,7,12,12,11,12,11,8,12,12,5,5,11,5,18,12,12,12,12,7,11,7,12,11,16,11,11,11,7,5,7,14,5,
2,
9,
18,
25,
950172},
};

ft_void_t Ft_App_WrCoCmd_Buffer(Ft_Gpu_Hal_Context_t *phost,ft_uint32_t cmd)
{
#ifdef  BUFFER_OPTIMIZATION
  /* Copy the command instruction into buffer */
  ft_uint32_t *pBuffcmd;
  pBuffcmd =(ft_uint32_t*)&Ft_CmdBuffer[Ft_CmdBuffer_Index];
  *pBuffcmd = cmd;
#endif
#ifdef ARDUINO_PLATFORM
  Ft_Gpu_Hal_WrCmd32(phost,cmd);
#endif

  /* Increment the command index */
  Ft_CmdBuffer_Index += FT_CMD_SIZE;
}

ft_void_t Ft_App_WrDlCmd_Buffer(Ft_Gpu_Hal_Context_t *phost,ft_uint32_t cmd)
{
#ifdef BUFFER_OPTIMIZATION
  /* Copy the command instruction into buffer */
  ft_uint32_t *pBuffcmd;
  pBuffcmd =(ft_uint32_t*)&Ft_DlBuffer[Ft_DlBuffer_Index];
  *pBuffcmd = cmd;
#endif

#ifdef ARDUINO_PLATFORM
  Ft_Gpu_Hal_Wr32(phost,(RAM_DL+Ft_DlBuffer_Index),cmd);
#endif
  /* Increment the command index */
  Ft_DlBuffer_Index += FT_CMD_SIZE;
}

ft_void_t Ft_App_WrCoStr_Buffer(Ft_Gpu_Hal_Context_t *phost,const ft_char8_t *s)
{
#ifdef  BUFFER_OPTIMIZATION
  ft_uint16_t length = 0;
  length = strlen(s) + 1;//last for the null termination

  strcpy(&Ft_CmdBuffer[Ft_CmdBuffer_Index],s);

  /* increment the length and align it by 4 bytes */
  Ft_CmdBuffer_Index += ((length + 3) & ~3);
#endif
}

ft_void_t Ft_App_Flush_DL_Buffer(Ft_Gpu_Hal_Context_t *phost)
{
#ifdef  BUFFER_OPTIMIZATION
  if (Ft_DlBuffer_Index > 0)
    Ft_Gpu_Hal_WrMem(phost,RAM_DL,Ft_DlBuffer,Ft_DlBuffer_Index);
#endif
  Ft_DlBuffer_Index = 0;

}


ft_void_t Ft_App_Flush_Co_Buffer(Ft_Gpu_Hal_Context_t *phost)
{
#ifdef  BUFFER_OPTIMIZATION
  if (Ft_CmdBuffer_Index > 0)
    Ft_Gpu_Hal_WrCmdBuf(phost,Ft_CmdBuffer,Ft_CmdBuffer_Index);
#endif
  Ft_CmdBuffer_Index = 0;
}

#if 0
/* API to give fadeout effect by changing the display PWM from 100 till 0 */
ft_void_t SAMAPP_fadeout()
{
  ft_int32_t i;

  for (i = 100; i >= 0; i -= 3)
  {
    Ft_Gpu_Hal_Wr8(phost,REG_PWM_DUTY,i);

    Ft_Gpu_Hal_Sleep(2);//sleep for 2 ms
  }
}

/* API to perform display fadein effect by changing the display PWM from 0 till 100 and finally 128 */
ft_void_t SAMAPP_fadein()
{
  ft_int32_t i;

  for (i = 0; i <=100 ; i += 3)
  {
    Ft_Gpu_Hal_Wr8(phost,REG_PWM_DUTY,i);
    Ft_Gpu_Hal_Sleep(2);//sleep for 2 ms
  }
  /* Finally make the PWM 100% */
  i = 128;
  Ft_Gpu_Hal_Wr8(phost,REG_PWM_DUTY,i);
}

#endif

//=====================================================================================================================================================//
/* Optimized implementation of sin and cos table - precision is 16  */
FT_PROGMEM ft_prog_uint16_t sintab[] =
{
  0, 402, 804, 1206, 1607, 2009, 2410, 2811, 3211, 3611, 4011, 4409, 4807, 5205, 5601, 5997, 6392,
  6786, 7179, 7571, 7961, 8351, 8739, 9126, 9511, 9895, 10278, 10659, 11038, 11416, 11792, 12166, 12539,
  12909, 13278, 13645, 14009, 14372, 14732, 15090, 15446, 15799, 16150, 16499, 16845, 17189, 17530, 17868,
  18204, 18537, 18867, 19194, 19519, 19840, 20159, 20474, 20787, 21096, 21402, 21705, 22004, 22301, 22594,
  22883, 23169, 23452, 23731, 24006, 24278, 24546, 24811, 25072, 25329, 25582, 25831, 26077, 26318, 26556, 26789,
  27019, 27244, 27466, 27683, 27896, 28105, 28309, 28510, 28706, 28897, 29085, 29268, 29446, 29621, 29790, 29955,
  30116, 30272, 30424, 30571, 30713, 30851, 30984, 31113, 31236, 31356, 31470, 31580, 31684, 31785, 31880, 31970,
  32056, 32137, 32213, 32284, 32350, 32412, 32468, 32520, 32567, 32609, 32646, 32678, 32705, 32727, 32744, 32757,
  32764, 32767, 32764
};

ft_int16_t qsin(ft_uint16_t a)
{
  ft_uint8_t f;
  ft_int16_t s0,s1;

  if (a & 32768)
    return -qsin(a & 32767);
  if (a & 16384)
    a = 32768 - a;
  f = a & 127;
  s0 = ft_pgm_read_word(sintab + (a >> 7));
  s1 = ft_pgm_read_word(sintab + (a >> 7) + 1);
  return (s0 + ((ft_int32_t)f * (s1 - s0) >> 7));
}

/* cos funtion */
ft_int16_t qcos(ft_uint16_t a)
{
  return (qsin(a + 16384));
}

/* API to check the status of previous DLSWAP and perform DLSWAP of new DL */
/* Check for the status of previous DLSWAP and if still not done wait for few ms and check again */
ft_void_t Ft_Gpu_DLSwap(ft_uint8_t DL_Swap_Type)
{
  ft_uint8_t Swap_Type = DLSWAP_FRAME,Swap_Done = DLSWAP_FRAME;

  if(DL_Swap_Type == DLSWAP_LINE)
  {
    Swap_Type = DLSWAP_LINE;
  }

  /* Perform a new DL swap */
  Ft_Gpu_Hal_Wr8(phost,REG_DLSWAP,Swap_Type);

  /* Wait till the swap is done */
  while(Swap_Done)
  {
    Swap_Done = Ft_Gpu_Hal_Rd8(phost,REG_DLSWAP);
    if(DLSWAP_DONE != Swap_Done)
    {
      Ft_Gpu_Hal_Sleep(10);//wait for 10ms
    }
  }
}



/*****************************************************************************/
/* Example code to display few points at various offsets with various colors */



/* Boot up for FT800 followed by graphics primitive sample cases */
/* Initial boot up DL - make the back ground green color */
const ft_uint8_t FT_DLCODE_BOOTUP[12] =
{
  255,255,255,2,//GPU instruction CLEAR_COLOR_RGB
  7,0,0,38, //GPU instruction CLEAR
  0,0,0,0,  //GPU instruction DISPLAY
};

static void polarxy(ft_int32_t r, float th, ft_int16_t *x, ft_int16_t *y,ft_uint16_t ox,ft_uint16_t oy)
{
  th = (th * 182.044);
  *x = (16 * ox + (((long)r * qsin(th)) >> 11) + 16);
  *y = (16 * oy - (((long)r * qcos(th)) >> 11));
}


static void polar(ft_int32_t r, float th,ft_uint16_t ox,ft_uint16_t oy)
{
  ft_int32_t x, y;
  th = (th * 182.044);
  x = (16 * ox + (((long)r * qsin(th)) >> 11) + 16);
  y = (16 * oy - (((long)r * qcos(th)) >> 11));
  Ft_Gpu_Hal_Transfer32(phost,VERTEX2F(x,y));
}
typedef struct
{
    ft_uint8_t fifo_busy:1;
    ft_uint8_t time_alert:1;
    ft_uint8_t audio_play:1;
    ft_uint8_t audio_load:1;
    ft_uint8_t date_set:1;
    ft_uint8_t am_pm:1;
}bitfield;

bitfield Flag;
static ft_uint8_t sd_present =0;


//================================Dec to binary and binary to dec =========================================
byte decToBcd(byte val)
{
  return ( (val/10*16) + (val%10) );
}

byte bcdToDec(byte val)
{
  return ( (val/16*10) + (val%16) );
}

/* API to load raw data from file into perticular locatio of ft800 */

ft_int32_t Ft_App_LoadRawFromFile(Reader &reader,ft_uint32_t DstAddr)
{
	ft_int32_t FileLen = 0,Ft800_addr = RAM_G;
	//ft_uint8_t *pbuff = NULL;
        ft_uint8_t pbuff[512];

#ifdef MSVC_PLATFORM  
	FILE *pFile = fopen(pFileName,"rb");//TBD - make platform specific
#endif

#ifdef MSVC_PLATFORM

	/* inflate the data read from binary file */
	if(NULL == pFile)
	{
		printf("Error in opening file %s \n",pFileName);
	}
	else
	{
#endif
		Ft800_addr = DstAddr;
#ifdef ARDUINO_PLATFORM
  reader.readsector(pbuff);
  reader.seek(0);
  FileLen = reader.size;
  //reader.seek(0);
#endif

#ifdef MSVC_PLATFORM
		fseek(pFile,0,SEEK_END);
		FileLen = ftell(pFile);
		fseek(pFile,0,SEEK_SET);
		pbuff = (ft_uint8_t *)malloc(8192);
#endif
		while(FileLen > 0)
		{
			/* download the data into the command buffer by 2kb one shot */
			ft_uint16_t blocklen = FileLen>8192?8192:FileLen;

			/* copy the data into pbuff and then transfter it to command buffer */
#ifdef MSVC_PLATFORM			
			fread(pbuff,1,blocklen,pFile);
#endif
			FileLen -= blocklen;
			/* copy data continuously into FT800 memory */
			Ft_Gpu_Hal_WrMem(phost,Ft800_addr,pbuff,blocklen);
			Ft800_addr += blocklen;
		}
		/* close the opened binary zlib file */
		//fclose(pFile);
		//free(pbuff);
	}

	return 0;
}

/* APIs useful for bitmap postprocessing */
/* Identity transform matrix */
ft_int16_t Ft_App_TrsMtrxLoadIdentity(Ft_App_GraphicsMatrix_t *pMatrix)
{
	/* Load the identity matrix into the input pointer */
	pMatrix->a = 1*FT_APP_MATIRX_PRECITION;
	pMatrix->b = 0*FT_APP_MATIRX_PRECITION;
	pMatrix->c = 0*FT_APP_MATIRX_PRECITION;
	pMatrix->d = 0*FT_APP_MATIRX_PRECITION;
	pMatrix->e = 1*FT_APP_MATIRX_PRECITION;
	pMatrix->f = 0*FT_APP_MATIRX_PRECITION;
	return 0;
}
ft_int16_t Ft_App_UpdateTrsMtrx(Ft_App_GraphicsMatrix_t *pMatrix,Ft_App_PostProcess_Transform_t *ptrnsmtrx)
{
	/* perform the translation from float to FT800 specific transform units */
	ptrnsmtrx->Transforma = pMatrix->a*FT_APP_MATRIX_GPU_PRECITION;
	ptrnsmtrx->Transformd = pMatrix->d*FT_APP_MATRIX_GPU_PRECITION;
	ptrnsmtrx->Transformb = pMatrix->b*FT_APP_MATRIX_GPU_PRECITION;
	ptrnsmtrx->Transforme = pMatrix->e*FT_APP_MATRIX_GPU_PRECITION;
	ptrnsmtrx->Transformc = pMatrix->c*FT_APP_MATRIX_GPU_PRECITION;
	ptrnsmtrx->Transformf = pMatrix->f*FT_APP_MATRIX_GPU_PRECITION;

	return 0;
}

/* give out the translated values. */
ft_int16_t Ft_App_TrsMtrxTranslate(Ft_App_GraphicsMatrix_t *pMatrix,float x,float y,float *pxres,float *pyres)
{
	float a,b,c,d,e,f;

	/* matrix multiplication */
	a = pMatrix->a;	b = pMatrix->b;	c = pMatrix->c;	d = pMatrix->d;	e = pMatrix->e;	f = pMatrix->f;

	*pxres = x*a + y*b + c;
	*pyres = x*d + y*e + f;
	pMatrix->c = *pxres;
	pMatrix->f = *pyres;

	return 0;
}
/* API for rotation of angle degree - using vc++ math library - if not then use array of sine tables to compule both sine and cosine */
/* +ve degree for anti clock wise and -ve for clock wise */
/* note not checking the overflow cases */
ft_int16_t Ft_App_TrsMtrxRotate(Ft_App_GraphicsMatrix_t *pMatrix,ft_int32_t th)
{
	double pi = 3.1415926535;
	double angle = -th*pi/180;
	Ft_App_GraphicsMatrix_t tempmtx,tempinput;


	tempinput.a = pMatrix->a;
	tempinput.b = pMatrix->b;
	tempinput.c = pMatrix->c;
	tempinput.d = pMatrix->d;
	tempinput.e = pMatrix->e;
	tempinput.f = pMatrix->f;

	Ft_App_TrsMtrxLoadIdentity(&tempmtx);
	tempmtx.a = cos(angle)*FT_APP_MATIRX_PRECITION;
	tempmtx.b = sin(angle)*FT_APP_MATIRX_PRECITION;
	tempmtx.d = -sin(angle)*FT_APP_MATIRX_PRECITION;
	tempmtx.e = cos(angle)*FT_APP_MATIRX_PRECITION;

	/* perform matrix multiplecation and store in the input */
	pMatrix->a = tempinput.a*tempmtx.a + tempinput.b*tempmtx.d;
	pMatrix->b = tempinput.a*tempmtx.b + tempinput.b*tempmtx.e;
	pMatrix->c = tempinput.a*tempmtx.c + tempinput.b*tempmtx.f + tempinput.c*1;
	pMatrix->d = tempinput.d*tempmtx.a + tempinput.e*tempmtx.d;
	pMatrix->e = tempinput.d*tempmtx.b + tempinput.e*tempmtx.e;
	pMatrix->f = tempinput.d*tempmtx.c + tempinput.e*tempmtx.f + tempinput.f*1;
	
	return 0;
}
/* Scaling done for x and y factors - from 1 to 255 */
/* Input units are in terms of 65536 */
ft_int16_t Ft_App_TrsMtrxScale(Ft_App_GraphicsMatrix_t *pMatrix,float xfactor,float yfactor)
{

	pMatrix->a /= xfactor;
	pMatrix->d /= xfactor;

	pMatrix->b /= yfactor;
	pMatrix->e /= yfactor;

	return 0;
}
/* flip the image - 1 for right flip, 2 for bottom flip */
ft_int16_t Ft_App_TrsMtrxFlip(Ft_App_GraphicsMatrix_t *pMatrix,ft_int32_t Option)
{
	/* need to verify both */
	if(FT_APP_GRAPHICS_FLIP_RIGHT == (Option & FT_APP_GRAPHICS_FLIP_RIGHT))
	{
		pMatrix->a = -pMatrix->a;
		pMatrix->d = -pMatrix->d;
	}
	if(FT_APP_GRAPHICS_FLIP_BOTTOM == (Option & FT_APP_GRAPHICS_FLIP_BOTTOM))
	{
		pMatrix->b = -pMatrix->b;
		pMatrix->e = -pMatrix->e;
	}

	return 0;
}
/* Arrawy used for custom fonts */
S_LiftAppFont_t G_LiftAppFontArrayNumbers[1] = 
{
	//font structure
	{
	/* Max Width */
	80,
	/* Max Height */
	156,
	/* Max Stride */
	80,
	/* format */
	L8,
	/* Each character width */
	80,80,80,80,80,80,80,80,80,80,80,80,
	}
};
S_LiftAppFont_t G_LiftAppFontArrayArrow[1] = 
{	//arrow structure
	{
	/* Max Width */
	80,
	/* Max Height */
	85,
	/* Max Stride */
	80,
	/* format */
	L8,
	/* Each character width */
	80,
	}
};
/* API to check the status of previous DLSWAP and perform DLSWAP of new DL */
/* Check for the status of previous DLSWAP and if still not done wait for few ms and check again */
ft_void_t Ft_App_GPU_DLSwap(ft_uint8_t DL_Swap_Type)
{
	ft_uint8_t Swap_Type = DLSWAP_FRAME,Swap_Done = DLSWAP_FRAME;

	if(DL_Swap_Type == DLSWAP_LINE)
	{
		Swap_Type = DLSWAP_LINE;
	}

	/* Perform a new DL swap */
	Ft_Gpu_Hal_Wr8(phost,REG_DLSWAP,Swap_Type);

	/* Wait till the swap is done */
	while(Swap_Done)
	{
		Swap_Done = Ft_Gpu_Hal_Rd8(phost,REG_DLSWAP);

		if(DLSWAP_DONE != Swap_Done)
		{
			Ft_Gpu_Hal_Sleep(10);//wait for 10ms
		}
	}	
}


/* API to compute the bitmap offset wrt input characters and scale 
   ResizeVal is in terms of 8 bits precision - ex 1 will be equal to 256
   xOffset and  yOffset are in terms of 4 bits precision - 1/16th pixel format and are the center of the display character
   Even the FT800 display list is generated in this API
*/
ft_int32_t FT_LiftAppComputeBitmap(S_LiftAppFont_t *pLAFont, ft_int32_t FloorNum,ft_uint8_t TotalNumChar,ft_int32_t ResizeVal,ft_int16_t xOffset,ft_int16_t yOffset)
{
	/* compute the total number of digits in the input */
	ft_uint8_t TotalChar = 1;
	ft_int32_t TotHzSz,TotVtSz,FlNum,i,xoff,yoff;
	ft_char8_t FontValArray[8];

	TotalChar = 1;
	FlNum = FloorNum;
	TotHzSz = pLAFont->MaxWidth;
	FontValArray[0] = '\0';//requirement from dec2ascii api

	Ft_Gpu_Hal_Dec2Ascii(FontValArray,FloorNum);
	TotalChar = strlen(FontValArray);
	if(0 != TotalNumChar)
	{
		TotalChar = TotalNumChar;
	}
	TotHzSz = (pLAFont->MaxWidth * 16 * ResizeVal)/LIFTAPPCHARRESIZEPRECISION;
	TotVtSz = (pLAFont->MaxHeight * 16 * ResizeVal)/LIFTAPPCHARRESIZEPRECISION;
	
	//change the x and y offset to center of the characters
	xoff = xOffset*16 - TotHzSz*TotalChar/2;
	yoff = yOffset*16 - TotVtSz/2;
	/* since resize value is same for both the sides the resize is same for all characters */
	for(i=0;i<TotalChar;i++)
	{
		/* Calculation of cell number from  */
		if('-' == FontValArray[i])
		{
			Ft_App_WrCoCmd_Buffer(phost,CELL(0));
		}
		else
		{

			Ft_App_WrCoCmd_Buffer(phost,CELL(FontValArray[i]-'0' + 1));
		}
		Ft_App_WrCoCmd_Buffer(phost,VERTEX2F(xoff,yoff));
		//increment the character after every ittiration
		xoff += TotHzSz;
	}
	return 0;
}

ft_int32_t FT_LiftAppComputeBitmapRowRotate(S_LiftAppFont_t *pLAFont, ft_int32_t FloorNum,ft_uint8_t TotalNumChar,ft_int32_t ResizeVal,ft_int16_t xOffset,ft_int16_t yOffset)
{
	/* compute the total number of digits in the input */
	ft_uint8_t TotalChar = 1;
	ft_int32_t TotHzSz,TotVtSz,FlNum,i,xoff,yoff;
	ft_char8_t FontValArray[8];

	TotalChar = 1;
	FlNum = FloorNum;
	TotHzSz = pLAFont->MaxWidth;
	FontValArray[0] = '\0';//requirement from dec2ascii api

	Ft_Gpu_Hal_Dec2Ascii(FontValArray,FloorNum);
	TotalChar = strlen(FontValArray);
	if(0 != TotalNumChar)
	{
		TotalChar = TotalNumChar;
	}
	TotHzSz = (pLAFont->MaxWidth * 16 * ResizeVal)/LIFTAPPCHARRESIZEPRECISION;
	TotVtSz = (pLAFont->MaxHeight * 16 * ResizeVal)/LIFTAPPCHARRESIZEPRECISION;
	
	//change the x and y offset to center of the characters
	xoff = xOffset*16 - TotVtSz/2;
	yoff = yOffset*16 - (TotHzSz*TotalChar/2) + (TotHzSz*(TotalChar-1));
	/* since resize value is same for both the sides the resize is same for all characters */
	for(i=0;i<TotalChar;i++)
	{
		/* Calculation of cell number from  */
		if('-' == FontValArray[i])
		{
			Ft_App_WrCoCmd_Buffer(phost,CELL(0));
		}
		else
		{

			Ft_App_WrCoCmd_Buffer(phost,CELL(FontValArray[i]-'0' + 1));
		}
		Ft_App_WrCoCmd_Buffer(phost,VERTEX2F(xoff,yoff));
		//increment the character after every ittiration
		yoff -= TotHzSz;
	}
	return 0;
}


/* API for floor number logic */
ft_int32_t FT_LiftApp_FTransition(S_LiftAppCtxt_t *pLACtxt,ft_uint32_t dstaddr)
{

	ft_char8_t StringArray[100],StringArray_mid[100],audio_array[100];
	ft_int32_t dst_addr_st_file;
	StringArray[0] = '\0';
	StringArray_mid[0] = '\0';
	/* check for the current floor number logic */
	if(pLACtxt->CurrFloorNum == pLACtxt->NextFloorNum)
	{

		/* first time only entry */
		if(LIFTAPP_DIR_NONE != pLACtxt->ArrowDir)
		{
			pLACtxt->CurrFloorNumStagnantRate = pLACtxt->SLATransPrms.FloorNumStagnantRate;
			pLACtxt->CurrFloorNumResizeRate = pLACtxt->SLATransPrms.ResizeRate;
		}
		/* Make the direction to 0 */
		pLACtxt->ArrowDir = LIFTAPP_DIR_NONE;//arrow is disabled in none direction
		{
			if(0 == pLACtxt->AudioPlaying)	
			{
				/* load the ring tone */
				dst_addr_st_file = play_music("merge_bell_floor.wav",dstaddr,1,0);

				/* load the floor number audio */
				strcat(StringArray_mid,"..\\..\\..\\Test\\");
				Ft_Gpu_Hal_Dec2Ascii(StringArray,(ft_int32_t)pLACtxt->CurrFloorNum);
				strcat(StringArray_mid, StringArray);
				strcat(StringArray_mid, ".wav");
				dst_addr_st_file = play_music(StringArray_mid,dst_addr_st_file,1,0);
				play_music(StringArray_mid,dstaddr,2,dst_addr_st_file - dstaddr);
				pLACtxt->AudioPlaying = 1;
			}
		}


		/* resizing of floor number */
		if(pLACtxt->CurrFloorNumResizeRate > 0)
		{
			pLACtxt->CurrFloorNumResizeRate--;
			return 0;
		}
		
		pLACtxt->CurrFloorNumResizeRate = 0;

		/* rate implmenetation */
		if(pLACtxt->CurrFloorNumStagnantRate > 0)
		{
			
			pLACtxt->CurrFloorNumStagnantRate--;//rate based logic
			return 0;//do not perform any thing

		}

		pLACtxt->CurrFloorNumStagnantRate = 0;
		pLACtxt->AudioPlaying = 0;
		/* delay the below code till rate is completed - modify the rate if application over rights */
		//limitation - make sure the max is +ve
		while((pLACtxt->CurrFloorNum == pLACtxt->NextFloorNum) || (0 == pLACtxt->NextFloorNum))//to make sure the same floor number is not assigned
		{
			pLACtxt->NextFloorNum = pLACtxt->SLATransPrms.MinFloorNum + ft_random(pLACtxt->SLATransPrms.MaxFloorNum - pLACtxt->SLATransPrms.MinFloorNum);
		}

		pLACtxt->ArrowDir = LIFTAPP_DIR_DOWN;
		/* generate a new random number and change the direction as well */
		if(pLACtxt->NextFloorNum > pLACtxt->CurrFloorNum)
		{
			pLACtxt->ArrowDir = LIFTAPP_DIR_UP;
			play_music("going_up_gold_wave.wav",dstaddr,0,0);
		}
		else
		{
			play_music("Going_down_amplified.wav",dstaddr,0,0);
		}

		/* set the starting of the arrow resize */
		pLACtxt->CurrArrowResizeRate = pLACtxt->SLATransPrms.ResizeRate;
		//set the curr floor number change 
		pLACtxt->CurrFloorNumChangeRate = pLACtxt->SLATransPrms.FloorNumChangeRate;
		return 0;
	}

	/* moving up or moving down logic */
	/* rate based on count */
	pLACtxt->CurrArrowResizeRate--;
	if(pLACtxt->CurrArrowResizeRate <= 0)
	{
		pLACtxt->CurrArrowResizeRate = pLACtxt->SLATransPrms.ResizeRate;
	}


	//changing floor numbers
	pLACtxt->CurrFloorNumChangeRate--;
	if(pLACtxt->CurrFloorNumChangeRate <= 0)
	{
		pLACtxt->CurrFloorNumChangeRate = pLACtxt->SLATransPrms.FloorNumChangeRate;
		//change the floor number wrt direction
		if(LIFTAPP_DIR_DOWN == pLACtxt->ArrowDir)
		{
			pLACtxt->CurrFloorNum -=1;
		}
		else
		{
			pLACtxt->CurrFloorNum +=1;
			if(0 == pLACtxt->CurrFloorNum)
			{
				pLACtxt->CurrFloorNum +=1;
			}
		}
	}
	return 0;
}

//API for single bitmap computation - follow the above api for more details
ft_int32_t FT_LiftAppComputeBitmap_Single(S_LiftAppFont_t *pLAFont, ft_int32_t BitmapIdx,ft_int32_t ResizeVal,ft_int16_t xOffset,ft_int16_t yOffset)
{
	/* compute the total number of digits in the input */
	ft_int32_t TotHzSz,TotVtSz,FlNum,i,xoff,yoff;

	TotHzSz = (pLAFont->MaxWidth * 16 * ResizeVal)/LIFTAPPCHARRESIZEPRECISION;
	TotVtSz = (pLAFont->MaxHeight * 16 * ResizeVal)/LIFTAPPCHARRESIZEPRECISION;
	
	//change the x and y offset to center of the characters
	xoff = xOffset*16 - TotHzSz/2;
	yoff = yOffset*16 - TotVtSz/2;

	Ft_App_WrCoCmd_Buffer(phost,CELL(BitmapIdx));
	Ft_App_WrCoCmd_Buffer(phost,VERTEX2F(xoff,yoff));

	return 0;
}

/* API to demonstrate calibrate widget/functionality */
ft_void_t SAMAPP_CoPro_Widget_Calibrate()
{
	ft_uint8_t *pbuff;
	ft_uint32_t NumBytesGen = 0,TransMatrix[6];
	ft_uint16_t CurrWriteOffset = 0;

	/*************************************************************************/
	/* Below code demonstrates the usage of calibrate function. Calibrate    */
	/* function will wait untill user presses all the three dots. Only way to*/
	/* come out of this api is to reset the coprocessor bit.                 */
	/*************************************************************************/
	{
	
	Ft_Gpu_CoCmd_Dlstart(phost);

	Ft_App_WrCoCmd_Buffer(phost,CLEAR_COLOR_RGB(64,64,64));
	Ft_App_WrCoCmd_Buffer(phost,CLEAR(1,1,1));
	Ft_App_WrCoCmd_Buffer(phost,COLOR_RGB(0xff,0xff,0xff));
	/* Draw number at 0,0 location */
	//Ft_App_WrCoCmd_Buffer(phost,COLOR_A(30));
	Ft_Gpu_CoCmd_Text(phost,(FT_DispWidth/2), (FT_DispHeight/2), 27, OPT_CENTER, "Please Tap on the dot");
	Ft_Gpu_CoCmd_Calibrate(phost,0);

	/* Download the commands into FIFIO */
	Ft_App_Flush_Co_Buffer(phost);
	/* Wait till coprocessor completes the operation */
	Ft_Gpu_Hal_WaitCmdfifo_empty(phost);
	/* Print the configured values */
	Ft_Gpu_Hal_RdMem(phost,REG_TOUCH_TRANSFORM_A,(ft_uint8_t *)TransMatrix,4*6);//read all the 6 coefficients
#ifdef MSVC_PLATFORM
	printf("Touch screen transform values are A 0x%x,B 0x%x,C 0x%x,D 0x%x,E 0x%x, F 0x%x",
		TransMatrix[0],TransMatrix[1],TransMatrix[2],TransMatrix[3],TransMatrix[4],TransMatrix[5]);
#endif
	}

}

float linear(float p1,float p2,ft_uint16_t t,ft_uint16_t rate)
{
       float st  = (float)t/rate;
       return p1+(st*(p2-p1));
}

/* Startup Screen Information*/ 

char *info[] = {  "FT800 Lift Application",
                          "API to demonstrate lift application,",
                          "with FTDI logo",
                          "& date and time display"
                       }; 


/********API to return the assigned TAG value when penup,for the primitives/widgets******/

static ft_uint8_t sk=0;
ft_uint8_t Read_Keys()
{
  static ft_uint8_t Read_tag=0,temp_tag=0,ret_tag=0;	
  Read_tag = Ft_Gpu_Hal_Rd8(phost,REG_TOUCH_TAG);
  ret_tag = NULL;
  if(Read_tag!=NULL)		
  {
    if(temp_tag!=Read_tag)
    {
      temp_tag = Read_tag;	
      sk = Read_tag;										
    }  
  }
  else
  {
    if(temp_tag!=0)
    {
      ret_tag = temp_tag;
    }  
    sk = 0;
  }
  return ret_tag;
}


/***********************API used to SET the ICON******************************************/
/*Refer the code flow in the flowchart availble in the Application Note */



ft_void_t Info()
{
  ft_uint16_t dloffset = 0,z;
// Touch Screen Calibration
  Ft_CmdBuffer_Index = 0;  
  Ft_Gpu_CoCmd_Dlstart(phost); 
  Ft_App_WrCoCmd_Buffer(phost,CLEAR(1,1,1));
  Ft_App_WrCoCmd_Buffer(phost,COLOR_RGB(255,255,255));
  Ft_Gpu_CoCmd_Text(phost,FT_DispWidth/2,FT_DispHeight/2,28,OPT_CENTERX|OPT_CENTERY,"Please tap on a dot");
  Ft_Gpu_CoCmd_Calibrate(phost,0);
  Ft_App_WrCoCmd_Buffer(phost,DISPLAY());
  Ft_Gpu_CoCmd_Swap(phost);
  Ft_App_Flush_Co_Buffer(phost);
  Ft_Gpu_Hal_WaitCmdfifo_empty(phost);
// Ftdi Logo animation  
  Ft_Gpu_CoCmd_Logo(phost);
  Ft_App_Flush_Co_Buffer(phost);
  while(0!=Ft_Gpu_Hal_Rd16(phost,REG_CMD_READ)); 
//Copy the Displaylist from DL RAM to GRAM
  dloffset = Ft_Gpu_Hal_Rd16(phost,REG_CMD_DL);
  dloffset -=4; 
  Ft_Gpu_Hal_WrCmd32(phost,CMD_MEMCPY);
  Ft_Gpu_Hal_WrCmd32(phost,STARTUP_ADDRESS);
  Ft_Gpu_Hal_WrCmd32(phost,RAM_DL);
  Ft_Gpu_Hal_WrCmd32(phost,dloffset);
//Enter into Info Screen
  do
  {
	Ft_CmdBuffer_Index = 0;  
    Ft_Gpu_CoCmd_Dlstart(phost);   
    Ft_Gpu_CoCmd_Append(phost,STARTUP_ADDRESS,dloffset);
//Reset the BITMAP properties used during Logo animation
    Ft_App_WrCoCmd_Buffer(phost,BITMAP_TRANSFORM_A(256));
    Ft_App_WrCoCmd_Buffer(phost,BITMAP_TRANSFORM_A(256));
    Ft_App_WrCoCmd_Buffer(phost,BITMAP_TRANSFORM_B(0));
    Ft_App_WrCoCmd_Buffer(phost,BITMAP_TRANSFORM_C(0));
    Ft_App_WrCoCmd_Buffer(phost,BITMAP_TRANSFORM_D(0));
    Ft_App_WrCoCmd_Buffer(phost,BITMAP_TRANSFORM_E(256));
    Ft_App_WrCoCmd_Buffer(phost,BITMAP_TRANSFORM_F(0));  
//Display the information with transparent Logo using Edge Strip  
	
    Ft_App_WrCoCmd_Buffer(phost,COLOR_RGB(219,180,150));
    Ft_App_WrCoCmd_Buffer(phost,COLOR_A(220));
    Ft_App_WrCoCmd_Buffer(phost,BEGIN(EDGE_STRIP_A));
    Ft_App_WrCoCmd_Buffer(phost,VERTEX2F(0,FT_DispHeight*16));
    Ft_App_WrCoCmd_Buffer(phost,VERTEX2F(FT_DispWidth*16,FT_DispHeight*16));
    Ft_App_WrCoCmd_Buffer(phost,COLOR_A(255));
    Ft_App_WrCoCmd_Buffer(phost,COLOR_RGB(0,0,0));

    Ft_Gpu_CoCmd_Text(phost,FT_DispWidth/2,20,28,OPT_CENTERX|OPT_CENTERY,info[0]);
    Ft_Gpu_CoCmd_Text(phost,FT_DispWidth/2,60,26,OPT_CENTERX|OPT_CENTERY,info[1]);
    Ft_Gpu_CoCmd_Text(phost,FT_DispWidth/2,90,26,OPT_CENTERX|OPT_CENTERY,info[2]);  
    Ft_Gpu_CoCmd_Text(phost,FT_DispWidth/2,120,26,OPT_CENTERX|OPT_CENTERY,info[3]);  
    Ft_Gpu_CoCmd_Text(phost,FT_DispWidth/2,FT_DispHeight-30,26,OPT_CENTERX|OPT_CENTERY,"Click to play");

	
//	Check if the Play key and change the color
    if(sk!='P')
    Ft_App_WrCoCmd_Buffer(phost,COLOR_RGB(255,255,255));
    else
	{
		Ft_App_WrCoCmd_Buffer(phost,COLOR_RGB(100,100,100));		
	}
    Ft_App_WrCoCmd_Buffer(phost,BEGIN(FTPOINTS));   
	
    Ft_App_WrCoCmd_Buffer(phost,POINT_SIZE(20*16));
    Ft_App_WrCoCmd_Buffer(phost,TAG('P'));
    Ft_App_WrCoCmd_Buffer(phost,VERTEX2F((FT_DispWidth/2)*16,(FT_DispHeight-60)*16));
	 Ft_App_WrCoCmd_Buffer(phost,CLEAR(0,1,0));

	  Ft_App_WrCoCmd_Buffer(phost, COLOR_RGB(255, 0, 0) );
	Ft_App_WrCoCmd_Buffer(phost, STENCIL_OP(INCR,INCR) );
	Ft_App_WrCoCmd_Buffer(phost, COLOR_MASK(0,0,0,0) );//mask all the colors
	Ft_App_WrCoCmd_Buffer(phost, BEGIN(EDGE_STRIP_L));

	Ft_App_WrCoCmd_Buffer(phost, VERTEX2II(((FT_DispWidth/2)-14+10),(FT_DispHeight-77+5),0,0));
	Ft_App_WrCoCmd_Buffer(phost, VERTEX2II(((FT_DispWidth/2)-2+15),(FT_DispHeight-67+8),0,0));
	Ft_App_WrCoCmd_Buffer(phost, VERTEX2II(((FT_DispWidth/2)-14+10),(FT_DispHeight-57+11),0,0));
	Ft_App_WrCoCmd_Buffer(phost, VERTEX2II(((FT_DispWidth/2)-14+10),(FT_DispHeight-77+5),0,0));
	Ft_App_WrCoCmd_Buffer(phost, END());
	Ft_App_WrCoCmd_Buffer(phost, COLOR_MASK(1,1,1,1) );//enable all the colors
	Ft_App_WrCoCmd_Buffer(phost, STENCIL_FUNC(EQUAL,1,255));
	Ft_App_WrCoCmd_Buffer(phost, BEGIN(EDGE_STRIP_L));
	Ft_App_WrCoCmd_Buffer(phost, VERTEX2II(FT_DispWidth,0,0,0));
	Ft_App_WrCoCmd_Buffer(phost, VERTEX2II(FT_DispWidth,FT_DispHeight,0,0));
	//Ft_App_WrCoCmd_Buffer(phost, END());
	
	Ft_App_WrCoCmd_Buffer(phost, STENCIL_OP(KEEP,KEEP));
	Ft_App_WrCoCmd_Buffer(phost, STENCIL_FUNC(ALWAYS,0,255));
	Ft_App_WrCoCmd_Buffer(phost,LINE_WIDTH(1*16));
	//Ft_App_WrCoCmd_Buffer(phost, COLOR_RGB(0, 0, 0) );
	Ft_App_WrCoCmd_Buffer(phost, BEGIN(LINE_STRIP));
	Ft_App_WrCoCmd_Buffer(phost, VERTEX2II(((FT_DispWidth/2)-14+10),(FT_DispHeight-77+5),0,0));
	Ft_App_WrCoCmd_Buffer(phost, VERTEX2II(((FT_DispWidth/2)-2+15),(FT_DispHeight-67+8),0,0));
	Ft_App_WrCoCmd_Buffer(phost, VERTEX2II(((FT_DispWidth/2)-14+10),(FT_DispHeight-57+11),0,0));
	Ft_App_WrCoCmd_Buffer(phost, VERTEX2II(((FT_DispWidth/2)-14+10),(FT_DispHeight-77+5),0,0));
	//Ft_App_WrCoCmd_Buffer(phost, END());



    //Ft_App_WrCoCmd_Buffer(phost,VERTEX2II((FT_DispWidth/2)-14,(FT_DispHeight-75),14,4));
    Ft_App_WrCoCmd_Buffer(phost,DISPLAY());
    Ft_Gpu_CoCmd_Swap(phost);
    Ft_App_Flush_Co_Buffer(phost);
    Ft_Gpu_Hal_WaitCmdfifo_empty(phost);
  }while(Read_Keys()!='P');
/* wait until Play key is not pressed*/ 
  /* To cover up some distortion while demo is being loaded */
    Ft_App_WrCoCmd_Buffer(phost, CMD_DLSTART);
  Ft_App_WrCoCmd_Buffer(phost,CLEAR_COLOR_RGB(255,255,255));
  Ft_App_WrCoCmd_Buffer(phost,CLEAR(1,1,1));
  Ft_App_WrCoCmd_Buffer(phost,DISPLAY());
  Ft_Gpu_CoCmd_Swap(phost);
  Ft_App_Flush_Co_Buffer(phost);
  Ft_Gpu_Hal_WaitCmdfifo_empty(phost);
}


/* API to play the music files */
ft_uint32_t play_music(ft_char8_t *pFileName,ft_uint32_t dstaddr,ft_uint8_t Option,ft_uint32_t Buffersz)
{
	
        // open the audio file from the SD card
        
#ifdef MSVC_PLATFORM        
        FILE *pFile = NULL;
#endif 
#ifdef ARDUINO_PLATFORM
        Reader reader;
        reader.seek(0);
#endif
        ft_uint8_t music_playing = 0;
	ft_uint32_t filesz = 0,chunksize = 16*1024,totalbufflen = 64*1024,currreadlen = 0;
	ft_uint8_t *pBuff = NULL;
	ft_uint32_t wrptr = dstaddr,return_val = 0;
	ft_uint32_t rdptr,freebuffspace;
	

	if(2 == Option)
	{
		Ft_Gpu_Hal_Wr32(phost, REG_PLAYBACK_START,dstaddr);//Audio playback start address 
		//Ft_Gpu_Hal_Wr32(phost, REG_PLAYBACK_LENGTH,totalbufflen);//Length of raw data buffer in bytes		
		Ft_Gpu_Hal_Wr32(phost, REG_PLAYBACK_LENGTH,Buffersz);
		Ft_Gpu_Hal_Wr16(phost, REG_PLAYBACK_FREQ,11025);//Frequency
		Ft_Gpu_Hal_Wr8(phost, REG_PLAYBACK_FORMAT,ULAW_SAMPLES);//Current sampling frequency
		Ft_Gpu_Hal_Wr8(phost, REG_PLAYBACK_LOOP,0);
		Ft_Gpu_Hal_Wr8(phost, REG_VOL_PB,255);				
		Ft_Gpu_Hal_Wr8(phost, REG_PLAYBACK_PLAY,1);		
		return 0;
	}
	if(0 == music_playing)
{
#ifdef MSVC_PLATFORM
  	pFile = fopen(pFileName,"rb+");
	fseek(pFile,0,SEEK_END);
	filesz = ftell(pFile);

      	fseek(pFile,42,SEEK_SET);
	filesz = 0;
	fread(&filesz,1,4,pFile);
	fileszsave = filesz;
#endif

#ifdef ARDUINO_PLATFORM
         reader.openfile(pFileName);
         reader.seek(0);
	//fseek(pFile,0,SEEK_END);
        filesz = pFile.size;
        reader.seek(42);
        filesz = 0;
        reader.readsector();
#endif        

	
	pBuff = (ft_uint8_t *)malloc(totalbufflen);

	while(filesz > 0)
	{
		currreadlen = filesz;

		if(currreadlen > chunksize)
		{
			currreadlen = chunksize;
		}
		fread(pBuff,1,currreadlen,pFile);
		
		Ft_Gpu_Hal_WrMemFromFlash(phost, wrptr, (ft_uint8_t *)pBuff,currreadlen);
		wrptr +=  currreadlen;
		if(wrptr > (dstaddr + totalbufflen))
		{
			wrptr = dstaddr;
		}
		
			
		filesz -= currreadlen;
	     
		if((0 == music_playing) && (0 == Option))
		{
			Ft_Gpu_Hal_Wr32(phost, REG_PLAYBACK_START,dstaddr);//Audio playback start address 
			Ft_Gpu_Hal_Wr32(phost, REG_PLAYBACK_LENGTH,fileszsave);
			Ft_Gpu_Hal_Wr16(phost, REG_PLAYBACK_FREQ,11025);//Frequency
			Ft_Gpu_Hal_Wr8(phost, REG_PLAYBACK_FORMAT,ULAW_SAMPLES);//Current sampling frequency
			Ft_Gpu_Hal_Wr8(phost, REG_PLAYBACK_LOOP,0);
			Ft_Gpu_Hal_Wr8(phost, REG_VOL_PB,255);				
			Ft_Gpu_Hal_Wr8(phost, REG_PLAYBACK_PLAY,1);		
		    music_playing = 1;
		}

		{
			//Check the frees0ace if the file has more
			rdptr = Ft_Gpu_Hal_Rd32(phost,REG_PLAYBACK_READPTR);
			while(totalbufflen < fileszsave)
			{
				Ft_Gpu_CoCmd_MemSet(phost,wrptr,0,chunksize);
			}

		}
	}

	//if read pointer is already passed over write pointer
	if (Ft_Gpu_Hal_Rd32(phost,REG_PLAYBACK_READPTR) > wrptr) {
		//wait till the read pointer will be wrapped over 
		while(Ft_Gpu_Hal_Rd32(phost,REG_PLAYBACK_READPTR) > wrptr);
	}
		fclose(pFile);
		free(pBuff);
		if(filesz == 0)
		{
			dstaddr = dstaddr + fileszsave;
			music_playing = 0;
			return dstaddr;
		}
	}
	else if(0 == Option)
	{
		rdptr = Ft_Gpu_Hal_Rd32(phost,REG_PLAYBACK_READPTR) - dstaddr;
		if((fileszsave <= rdptr) || (0 == rdptr))
		{
			music_playing = 0;
		}
		
	}
	
	/* return the current write pointer in any case */
	return wrptr;
}

ft_void_t font_display(ft_int16_t BMoffsetx,ft_int16_t BMoffsety,ft_uint32_t stringlenghth,ft_char8_t *string_display)
{
	ft_uint16_t k;
	for(k=0;k<stringlenghth;k++)
		{
			Ft_App_WrCoCmd_Buffer(phost, VERTEX2II(BMoffsetx,BMoffsety,8,string_display[k]));
			BMoffsety -= g_Gpu_Fonts[8].FontWidth[string_display[k]];
		}
}


//=========================== Read/ Write RTC =============================================================

void Rtc_puts()
{
  temp_time[0] = 0x80 | decToBcd(Rtc.Secs);
  Rtc.Hrs &= 0x1f;
  temp_time[2] = decToBcd(Rtc.Hrs)|0x60;
  if(Flag.am_pm==0)                // am
  {
    temp_time[2] = decToBcd(Rtc.Hrs)|0x40;
  }
  temp_time[1] = decToBcd(Rtc.Mins);
  temp_time[4] = decToBcd(Rtc.date);
  temp_time[5] = decToBcd(Rtc.month);
  temp_time[6] = decToBcd(Rtc.year);
  hal_rtc_i2c_write(0,(ft_uint8_t*)&temp_time,7);
}

// Gets the date and time from the ds1307
void Rtc_gets()
{
  hal_rtc_i2c_read(0,(ft_uint8_t*)&temp_time,7);
  Flag.am_pm = ((temp_time[2])>>5)&0x01;
  Rtc.Hrs = bcdToDec((temp_time[2] & 0x1f));
  Rtc.Mins = bcdToDec((temp_time[1] & 0x7f));
  Rtc.Secs = bcdToDec((temp_time[0] & 0x7f));
  Rtc.date =  bcdToDec((temp_time[4]&0x3f));
  Rtc.month =   bcdToDec((temp_time[5]&0x1f));
  Rtc.year =   bcdToDec((temp_time[6]&0xff));
}


/*  API to construct the display list of the lift application*/
ft_void_t FT_LiftApp_Portrait()
{
	/* Download the raw data of custom fonts into memory */
	ft_int16_t BMoffsetx,BMoffsety,BHt = 156,BWd = 80,BSt = 80,Bfmt = L8,BArrowHt = 85,BArrowWd = 80,BArrowSt = 80,BArrowfmt = L8;
	ft_int16_t NumBallsRange = 6, NumBallsEach = 10,RandomVal = 16;
	ft_int32_t Baddr0,Baddr1,Baddr2,Baddr3,i,SzInc = 16,SzFlag = 0;
	ft_uint8_t fontr = 255,fontg = 255,fontb = 255;
	S_LiftAppRate_t *pLARate;
	S_LiftAppTrasParams_t *pLATParams;
	S_LiftAppBallsLinear_t S_LiftBallsArray[8*10],*pLiftBalls = NULL;//as of now 80 balls are been plotted
	Ft_App_GraphicsMatrix_t S_GPUMatrix;
	Ft_App_PostProcess_Transform_t S_GPUTrasMatrix;
	float temptransx,temptransy,running_rate;
	S_LiftAppCtxt_t S_LACtxt;
	//SYSTEMTIME st, lt;
	ft_uint16_t hour,hour_st,hour_nd,min,min_st,min_nd,sec,year,month,day,year_st_nd_dig,year_st_dig,year_nd_dig,year_rd_frth_dig,year_rd_dig,year_frth_dig;
	ft_uint16_t day_st, day_nd;
	ft_char8_t *day_of_week,nd_line[100];
	ft_char8_t text_run_disp[] = "The running text is displayed here.";
	ft_char8_t *hour_st_str, *hour_nd_str, *min_st_str, *min_nd_str,*day_st_str,*day_nd_str,*year_st_str, *year_nd_str, *year_rd_str, *year_frth_str;
	ft_char8_t* month_of_year;
	ft_uint32_t stringlen,FontTableAddress,k,j,l,stringlen_week,stringlen_day,stringlen_text_run_disp,stringlen_st;
	ft_int32_t FontWid = 0;

	ft_uint8_t *pbuff;
	ft_int32_t FileLen=0;
	FT_Gpu_Fonts_t Display_fontstruct;
	float t = 0;
	ft_uint16_t m;

	nd_line[0] = '0';
        Reader reader;
        byte file = 0; 
 

	/* load the bitmap raw data */

	/* Initial setup code to setup all the required bitmap handles globally */
	Ft_DlBuffer_Index = 0;
	pLARate = &S_LACtxt.SLARate;
	pLATParams = &S_LACtxt.SLATransPrms;

	//initialize all the rate parameters
	pLARate->CurrTime = 0;
	pLARate->IttrCount = 0;

	/* Initialize all the transition parameters - all the below are in terms of basic units of rate
	either they can be based on itterations or based on time giffies */
	pLATParams->FloorNumChangeRate = 64;
	pLATParams->MaxFloorNum = 90;
	pLATParams->MinFloorNum = 70;
	pLATParams->ResizeRate = 32;
	pLATParams->ResizeDimMax = 2*256;
	pLATParams->ResizeDimMin = 1*256;
	pLATParams->FloorNumStagnantRate = 128;

	/* Initialization of lift context parameters */
	S_LACtxt.ArrowDir = LIFTAPP_DIR_DOWN;//going down direction
	S_LACtxt.CurrFloorNum = 87;//current floor number to start with
	S_LACtxt.NextFloorNum = 80;//destination floor number as of now
	S_LACtxt.CurrArrowResizeRate = pLATParams->ResizeRate;
	S_LACtxt.CurrFloorNumResizeRate = pLATParams->ResizeRate;
	S_LACtxt.CurrFloorNumStagnantRate = 0;
	S_LACtxt.CurrFloorNumChangeRate = S_LACtxt.SLATransPrms.FloorNumChangeRate;
	S_LACtxt.AudioPlaying = 0;

	//display_logo();

	Baddr0 = RAM_G;
        reader.openfile("auroragen2_gimpl8_resize_80x156x11.raw");
        Ft_App_LoadRawFromFile(reader,RAM_G);
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_HANDLE(0));//handle 0 is used for all the characters
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_SOURCE(Baddr0));
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_LAYOUT(Bfmt, BSt, BHt));
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_SIZE(BILINEAR, BORDER, BORDER, BHt*2, BHt*2));//make sure whole bitmap is displayed after rotation - as height is greater than width

	Baddr1 = ((Baddr0 + BSt*BHt*11 + 15)&~15);
        reader.openfile("auroragen2_gimpl8_resize_arrow_80x85.raw");
	Ft_App_LoadRawFromFile(reader,Baddr1);
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_HANDLE(1));//bitmap handle 1 is used for arrow
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_SOURCE(Baddr1));
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_LAYOUT(BArrowfmt, BArrowSt, BArrowHt));
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_SIZE(BILINEAR, BORDER, BORDER, BArrowHt*2, BArrowHt*2));//make sure whole bitmap is displayed after rotation - as height is greater than width

	Baddr2 = Baddr1 + 80*85;
        reader.openfile("black-and-blue-star-background_60_55.raw");
	Ft_App_LoadRawFromFile(reader,Baddr2);
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_HANDLE(2));//bitmap handle 2 is used for background balls
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_SOURCE(Baddr2));
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_LAYOUT(L8, 60, 55));
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_SIZE(NEAREST, BORDER, BORDER, 60, 55));

	Baddr2 += 60*55;
        reader.openfile("black-and-blue-star-background_50_46.raw");
	Ft_App_LoadRawFromFile(reader,Baddr2);
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_HANDLE(3));//bitmap handle 2 is used for background balls
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_SOURCE(Baddr2));
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_LAYOUT(L8, 50, 46));
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_SIZE(NEAREST, BORDER, BORDER, 50, 46));

	Baddr2 += 50*46;
        reader.openfile("black-and-blue-star-background_40_37.raw");
	Ft_App_LoadRawFromFile(reader,Baddr2);
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_HANDLE(4));//bitmap handle 2 is used for background balls
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_SOURCE(Baddr2));
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_LAYOUT(L8,40,37));
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_SIZE(NEAREST, BORDER, BORDER,40,37));

        Baddr2 += 40*37;
	reader.openfile("black-and-blue-star-background_30_27.raw");
	Ft_App_LoadRawFromFile(reader,Baddr2);
        Ft_App_WrDlCmd_Buffer(phost,BITMAP_HANDLE(5));//bitmap handle 2 is used for background balls
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_SOURCE(Baddr2));
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_LAYOUT(L8, 30, 27));
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_SIZE(NEAREST, BORDER, BORDER, 30, 27));

	Baddr2 += 30*27;
	reader.openfile("black-and-blue-star-background_20_18.raw");
	Ft_App_LoadRawFromFile(reader,Baddr2);
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_HANDLE(6));//bitmap handle 2 is used for background balls
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_SOURCE(Baddr2));
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_LAYOUT(L8, 20, 18));
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_SIZE(NEAREST, BORDER, BORDER, 20, 18));

	Baddr2 += 20*18;
        reader.openfile("black-and-blue-star-background_10_10.raw");
	Ft_App_LoadRawFromFile(reader,Baddr2);
        Ft_App_WrDlCmd_Buffer(phost,BITMAP_HANDLE(7));//bitmap handle 2 is used for background balls
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_SOURCE(Baddr2));
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_LAYOUT(L8, 10, 10));
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_SIZE(NEAREST, BORDER, BORDER, 10, 10));

	Baddr2 += 10*10;
	Ft_App_LoadRawFromFile("ftdi_logo_ARGB4_.raw",Baddr2);
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_HANDLE(11));//handle 11 is used for logo
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_SOURCE(Baddr2));
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_LAYOUT(ARGB4, 129*2, 50));
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_SIZE(BILINEAR, BORDER, BORDER, 512, 512));//make sure whole bitmap is displayed after rotation - as height is greater than width
	Baddr2 += 129*2*50;

	// Read the font address from 0xFFFFC location 
	FontTableAddress = Ft_Gpu_Hal_Rd32(phost,0xFFFFC);
	
	Ft_CmdBuffer_Index = 0;
	
	/* Download the commands into fifo */	
	Ft_App_Flush_Co_Buffer(phost);

	/* Wait till coprocessor completes the operation */
	Ft_Gpu_Hal_WaitCmdfifo_empty(phost);

	Ft_App_WrDlCmd_Buffer(phost, BITMAP_HANDLE(8));
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_LAYOUT(L4,9,25));
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_SOURCE(950172));
	Ft_App_WrDlCmd_Buffer(phost,BITMAP_SIZE(NEAREST, BORDER, BORDER, 50, 50));
	
	Baddr2 += 10*10;

	Baddr2 =  ((Baddr2 + 7)&~7);//audio engine's requirement
	
	Ft_App_WrDlCmd_Buffer(phost, DISPLAY());
	/* Download the DL into DL RAM */
	Ft_App_Flush_DL_Buffer(phost);

	/* Do a swap */
	Ft_App_GPU_DLSwap(DLSWAP_FRAME);
	Ft_Gpu_Hal_Sleep(30);

	/* compute the random values at the starting */
	pLiftBalls = S_LiftBallsArray;
	for(i=0;i<(NumBallsRange*NumBallsEach);i++)
	{
		//always start from the right and move towards left
		pLiftBalls->xOffset = ft_random(FT_DispWidth*16);
		pLiftBalls->yOffset = ft_random(FT_DispHeight*16);
		pLiftBalls->dx = -1*ft_random(RandomVal*8);//always -ve
		pLiftBalls->dy = ft_random(RandomVal*8) - RandomVal*4;
		pLiftBalls++;
	}


	while(1)
	{		
		/* Logic of user touch - change background or skin wrt use touch */
		/* Logic of transition - change of floor numbers and direction */
		FT_LiftApp_FTransition(&S_LACtxt,Baddr2);		
		Ft_Gpu_CoCmd_Dlstart(phost);
		Ft_App_WrCoCmd_Buffer(phost, CLEAR_COLOR_RGB(255, 255, 255));
		Ft_App_WrCoCmd_Buffer(phost, CLEAR(1, 1, 1)); // clear screen
		Ft_App_WrCoCmd_Buffer(phost,COLOR_RGB(255,255,255));
		Ft_App_WrCoCmd_Buffer(phost,SAVE_CONTEXT());
		/* Background gradient */
		Ft_Gpu_CoCmd_Gradient(phost, 0,0,0x66B4E8,480,0,0x132B3B);


		/* Draw background bitmaps */
		Ft_App_WrCoCmd_Buffer(phost,COLOR_RGB(0,0,0));
		pLiftBalls = S_LiftBallsArray;
		Ft_App_WrCoCmd_Buffer(phost,BEGIN(BITMAPS));
		
		Ft_App_WrCoCmd_Buffer(phost,COLOR_A(64));
		Ft_App_WrCoCmd_Buffer(phost,COLOR_RGB(255,255,255));
		for(i=0;i<(NumBallsRange*NumBallsEach);i++)
		{			
			if(0 == i%NumBallsEach)
			{				
				Ft_App_WrCoCmd_Buffer(phost,BITMAP_HANDLE(2 + (i/NumBallsEach)));
			}
			if( ( (pLiftBalls->xOffset > ((FT_DispWidth + 60)*16)) || (pLiftBalls->yOffset > ((FT_DispHeight + 60) *16)) ) ||
				( (pLiftBalls->xOffset < (-60*16)) || (pLiftBalls->yOffset < (-60*16)) ))
			{
				pLiftBalls->xOffset = FT_DispWidth*16 + ft_random(80*16);
				pLiftBalls->yOffset = ft_random(FT_DispHeight*16);
				pLiftBalls->dx = -1*ft_random(RandomVal*8);
				pLiftBalls->dy = ft_random(RandomVal*8) - RandomVal*4;

			}
			Ft_App_WrCoCmd_Buffer(phost,VERTEX2F(pLiftBalls->xOffset, pLiftBalls->yOffset));
			pLiftBalls->xOffset += pLiftBalls->dx;
			pLiftBalls->yOffset += pLiftBalls->dy;
			pLiftBalls++;
		}
		Ft_App_WrCoCmd_Buffer(phost,END());
		Ft_App_WrCoCmd_Buffer(phost,ALPHA_FUNC(ALWAYS,0));
		Ft_App_WrCoCmd_Buffer(phost,COLOR_A(255));

		if(LIFTAPP_DIR_NONE != S_LACtxt.ArrowDir)//do not display the arrow in case of no direction, meaning stagnant
		{

			//calculation of size value based on the rate
			//the bitmaps are scaled from original resolution till 2 times the resolution on both x and y axis
			SzInc = 16 + (S_LACtxt.SLATransPrms.ResizeRate/2 - abs(S_LACtxt.CurrArrowResizeRate%S_LACtxt.SLATransPrms.ResizeRate - S_LACtxt.SLATransPrms.ResizeRate/2));
			Ft_App_WrCoCmd_Buffer(phost, COLOR_RGB(fontr, fontg, fontb));
			/* Draw the arrow first */
			Ft_App_WrCoCmd_Buffer(phost,BITMAP_HANDLE(1)); 
			Ft_App_WrCoCmd_Buffer(phost,BEGIN(BITMAPS)); // start drawing bitmaps
			//BMoffsetx = ((FT_DispWidth/4) - (BArrowWd*SzInc/32));
			BMoffsetx = (BArrowWd - (BArrowWd*SzInc/32));
			BMoffsety = ((FT_DispHeight/2) - (BArrowHt*SzInc/32));

			/* perform inplace flip and scale of bitmap in case of direction is up */
			Ft_App_TrsMtrxLoadIdentity(&S_GPUMatrix);
			Ft_App_TrsMtrxTranslate(&S_GPUMatrix,80/2.0,85/2.0,&temptransx,&temptransy);
			Ft_App_TrsMtrxScale(&S_GPUMatrix,(SzInc/16.0),(SzInc/16.0));
			Ft_App_TrsMtrxRotate(&S_GPUMatrix,90);
			if(LIFTAPP_DIR_UP == S_LACtxt.ArrowDir)
			{
				Ft_App_TrsMtrxFlip(&S_GPUMatrix,FT_APP_GRAPHICS_FLIP_RIGHT);		
			}

			Ft_App_TrsMtrxTranslate(&S_GPUMatrix,(-80*SzInc)/32.0,(-85*SzInc)/32.0,&temptransx,&temptransy);
			Ft_App_UpdateTrsMtrx(&S_GPUMatrix,&S_GPUTrasMatrix);
			Ft_App_WrCoCmd_Buffer(phost,BITMAP_TRANSFORM_A(S_GPUTrasMatrix.Transforma));
			Ft_App_WrCoCmd_Buffer(phost,BITMAP_TRANSFORM_B(S_GPUTrasMatrix.Transformb));
			Ft_App_WrCoCmd_Buffer(phost,BITMAP_TRANSFORM_C(S_GPUTrasMatrix.Transformc));
			Ft_App_WrCoCmd_Buffer(phost,BITMAP_TRANSFORM_D(S_GPUTrasMatrix.Transformd));
			Ft_App_WrCoCmd_Buffer(phost,BITMAP_TRANSFORM_E(S_GPUTrasMatrix.Transforme));
			Ft_App_WrCoCmd_Buffer(phost,BITMAP_TRANSFORM_F(S_GPUTrasMatrix.Transformf));

			FT_LiftAppComputeBitmap_Single(G_LiftAppFontArrayArrow,0,SzInc*16,BArrowWd,(FT_DispHeight/2));
			Ft_Gpu_CoCmd_LoadIdentity(phost);
			Ft_Gpu_CoCmd_SetMatrix(phost);
		}

		
		/* algorithm for animation - floor numbers will change in dimensions when stagnant at a perticular floor */
		/* arrow will change in case of movement of lift */
		/* display the bitmap with increased size */
		SzInc = 16 + (S_LACtxt.SLATransPrms.ResizeRate/2 - abs(S_LACtxt.CurrFloorNumResizeRate%S_LACtxt.SLATransPrms.ResizeRate - S_LACtxt.SLATransPrms.ResizeRate/2));
		BMoffsetx = FT_DispWidth - BWd*2 - (BWd*SzInc/32);
		BMoffsety = ((FT_DispHeight/2) - (BHt*SzInc/32));

		/* calculate the resolution change based on the number of characters used as well as */
		Ft_App_WrCoCmd_Buffer(phost, COLOR_RGB(fontr, fontg, fontb));
		/* perform inplace flip and scale of bitmap in case of direction is up */
		Ft_App_TrsMtrxLoadIdentity(&S_GPUMatrix);
		Ft_App_TrsMtrxTranslate(&S_GPUMatrix,BWd/2.0,BHt/2.0,&temptransx,&temptransy);
		Ft_App_TrsMtrxScale(&S_GPUMatrix,(SzInc/16.0),(SzInc/16.0));
		Ft_App_TrsMtrxRotate(&S_GPUMatrix,90);
		Ft_App_TrsMtrxTranslate(&S_GPUMatrix,(-BHt*SzInc)/32.0,(-BWd*SzInc)/32.0,&temptransx,&temptransy);
		Ft_App_UpdateTrsMtrx(&S_GPUMatrix,&S_GPUTrasMatrix);
		Ft_App_WrCoCmd_Buffer(phost,BITMAP_TRANSFORM_A(S_GPUTrasMatrix.Transforma));
		Ft_App_WrCoCmd_Buffer(phost,BITMAP_TRANSFORM_B(S_GPUTrasMatrix.Transformb));
		Ft_App_WrCoCmd_Buffer(phost,BITMAP_TRANSFORM_C(S_GPUTrasMatrix.Transformc));
		Ft_App_WrCoCmd_Buffer(phost,BITMAP_TRANSFORM_D(S_GPUTrasMatrix.Transformd));
		Ft_App_WrCoCmd_Buffer(phost,BITMAP_TRANSFORM_E(S_GPUTrasMatrix.Transforme));
		Ft_App_WrCoCmd_Buffer(phost,BITMAP_TRANSFORM_F(S_GPUTrasMatrix.Transformf));

		Ft_App_WrCoCmd_Buffer(phost,BITMAP_HANDLE(0)); 
		Ft_App_WrCoCmd_Buffer(phost,BEGIN(BITMAPS)); // start drawing bitmaps
		FT_LiftAppComputeBitmapRowRotate(G_LiftAppFontArrayNumbers,S_LACtxt.CurrFloorNum,0,SzInc*16,FT_DispWidth - BHt,(FT_DispHeight/2));
		






 // hrs
  th = (Rtc.Hrs*30) + (Rtc.Mins * 0.5);
  polarxy((ft_int32_t)(0.400*Clock_Size),th+0,&x0,&y0,Ox,Oy);
  polarxy((ft_int32_t)(0.200*Clock_Size),th+180,&x1,&y1,Ox,Oy);
  Vc1_Cleanline((ft_int32_t)(0.037 * Clock_Size * 16),x0,y0,x1,y1);
// minutes

  th = (Rtc.Mins*6) + (Rtc.Secs * 0.1);
  Ft_Gpu_Hal_Transfer32(phost,LINE_WIDTH((ft_int32_t)(0.18 * Clock_Size * 16)));
  Ft_Gpu_Hal_Transfer32(phost,COLOR_MASK(0,0,0,0));
  Ft_Gpu_Hal_Transfer32(phost,TAG(CLOCK_MINTAG));
  polar((ft_int32_t)(0.500*Clock_Size),th+0,Ox,Oy);
  polar((ft_int32_t)(0.100*Clock_Size),th+180,Ox,Oy);
  Ft_Gpu_Hal_Transfer32(phost,COLOR_MASK(1,1,1,1));

  polarxy((ft_int32_t)(0.750*Clock_Size),th+0,&x0,&y0,Ox,Oy);
  polarxy((ft_int32_t)(0.200*Clock_Size),th+180,&x1,&y1,Ox,Oy);
  Vc1_Cleanline((ft_int32_t)(0.037 * Clock_Size * 16),x0,y0,x1,y1);
  Ft_Gpu_Hal_Transfer32(phost,TAG_MASK(0));

// secs
  Ft_Gpu_Hal_Transfer32(phost,COLOR_RGB((seccolor>>16)&0xff,(seccolor>>8)&0xff,(seccolor>>0)&0xff));			// backround color
  Ft_Gpu_Hal_Transfer32(phost,LINE_WIDTH((ft_int32_t)(0.014 * Clock_Size * 16)));
  th =  Rtc.mSecs*0.006+Rtc.Secs*6;
  polar((ft_int32_t)(0.650*Clock_Size),th,Ox,Oy);
  polar((ft_int32_t)(0.300*Clock_Size),th+180,Ox,Oy);




		BMoffsetx = ((FT_DispWidth /2) + 210);
		BMoffsety = ((FT_DispHeight /2) + 130);
		stringlen_text_run_disp = strlen(text_run_disp);
		if(t < 200)
			t++;
		BMoffsety = linear(0,272,t,200);
		font_display(BMoffsetx,BMoffsety,stringlen_text_run_disp,text_run_disp);

			
		/*running_rate = */linear((BMoffsety + 130),(BMoffsety +250),0,200);
		Ft_App_WrCoCmd_Buffer(phost,RESTORE_CONTEXT());
		Ft_Gpu_CoCmd_LoadIdentity(phost);
		Ft_Gpu_CoCmd_Translate(phost,129*65536,50*65536);
		Ft_Gpu_CoCmd_Rotate(phost,270*65536/360);
		Ft_Gpu_CoCmd_Translate(phost,-80*65536,-50*65536);
		Ft_Gpu_CoCmd_SetMatrix(phost);

		Ft_App_WrCoCmd_Buffer(phost,BEGIN(BITMAPS));
		Ft_App_WrCoCmd_Buffer(phost,BITMAP_HANDLE(11));
		//Ft_App_WrCoCmd_Buffer(phost,VERTEX2F(-100*16,120*16));
		Ft_App_WrCoCmd_Buffer(phost,VERTEX2F(-80*16,150*16));
		Ft_App_WrCoCmd_Buffer(phost, DISPLAY() );
		Ft_Gpu_CoCmd_Swap(phost);
		/* Download the commands into fifo */
		Ft_App_Flush_Co_Buffer(phost);
		t++;
		/* Wait till coprocessor completes the operation */
		Ft_Gpu_Hal_WaitCmdfifo_empty(phost);
		//rate count increment - 
		pLARate->IttrCount++;
	}

}


#ifdef MSVC_PLATFORM
/* Main entry point */
ft_int32_t main(ft_int32_t argc,ft_char8_t *argv[])
#endif
#ifdef ARDUINO_PLATFORM
ft_void_t setup()
#endif
{
  /* Local variables */
  ft_uint8_t chipid;

  Ft_Gpu_HalInit_t halinit;

  halinit.TotalChannelNum = 1;
  Ft_Gpu_Hal_Init(&halinit);
  host.hal_config.channel_no = 0;
#ifdef MSVC_PLATFORM_SPI
  host.hal_config.spi_clockrate_khz = 12000; //in KHz
#endif
#ifdef ARDUINO_PLATFORM_SPI
  host.hal_config.spi_clockrate_khz = 4000; //in KHz
#endif
  Ft_Gpu_Hal_Open(&host);

  phost = &host;

  /* Do a power cycle for safer side */
  Ft_Gpu_Hal_Powercycle(phost);
  Ft_Gpu_Hal_Rd16(phost,RAM_G);
  /* Set the clk to external clock */
  Ft_Gpu_HostCommand(phost,FT_GPU_EXTERNAL_OSC);
  Ft_Gpu_Hal_Sleep(10);


  /* Switch PLL output to 48MHz */
  Ft_Gpu_HostCommand(phost,FT_GPU_PLL_48M);
  Ft_Gpu_Hal_Sleep(10);

  /* Do a core reset for safer side */
  Ft_Gpu_HostCommand(phost,FT_GPU_CORE_RESET);
  //Ft_Gpu_CoreReset(phost);

  /* Access address 0 to wake up the FT800 */
  Ft_Gpu_HostCommand(phost,FT_GPU_ACTIVE_M);

  {
    //Read Register ID to check if FT800 is ready.
    chipid = Ft_Gpu_Hal_Rd8(phost, REG_ID);
    while(chipid != 0x7C)
      chipid = Ft_Gpu_Hal_Rd8(phost, REG_ID);
#ifdef MSVC_PLATFORM
    printf("VC1 register ID after wake up %x\n",chipid);
#endif
  }
//Calibration for WQVA

  /* Configuration of LCD display */
#if 0// SAMAPP_DISPLAY_QVGA
  /* Values specific to QVGA LCD display */
  FT_DispWidth = 320;
  FT_DispHeight = 240;
  FT_DispHCycle =  408;
  FT_DispHOffset = 70;
  FT_DispHSync0 = 0;
  FT_DispHSync1 = 10;
  FT_DispVCycle = 263;
  FT_DispVOffset = 13;
  FT_DispVSync0 = 0;
  FT_DispVSync1 = 2;
  FT_DispPCLK = 8;
  FT_DispSwizzle = 2;
  FT_DispPCLKPol = 0;

#endif

  Ft_Gpu_Hal_Wr16(phost, REG_HCYCLE, FT_DispHCycle);
  Ft_Gpu_Hal_Wr16(phost, REG_HOFFSET, FT_DispHOffset);
  Ft_Gpu_Hal_Wr16(phost, REG_HSYNC0, FT_DispHSync0);
  Ft_Gpu_Hal_Wr16(phost, REG_HSYNC1, FT_DispHSync1);
  Ft_Gpu_Hal_Wr16(phost, REG_VCYCLE, FT_DispVCycle);
  Ft_Gpu_Hal_Wr16(phost, REG_VOFFSET, FT_DispVOffset);
  Ft_Gpu_Hal_Wr16(phost, REG_VSYNC0, FT_DispVSync0);
  Ft_Gpu_Hal_Wr16(phost, REG_VSYNC1, FT_DispVSync1);
  Ft_Gpu_Hal_Wr8(phost, REG_SWIZZLE, FT_DispSwizzle);
  Ft_Gpu_Hal_Wr8(phost, REG_PCLK_POL, FT_DispPCLKPol);
  Ft_Gpu_Hal_Wr8(phost, REG_PCLK,FT_DispPCLK);//after this display is visible on the LCD
  Ft_Gpu_Hal_Wr16(phost, REG_HSIZE, FT_DispWidth);
  Ft_Gpu_Hal_Wr16(phost, REG_VSIZE, FT_DispHeight);

  /* Initially fill both ping and pong buffer */
  Ft_Gpu_Hal_Wr8(phost, REG_GPIO_DIR,0xff);
  Ft_Gpu_Hal_Wr8(phost, REG_GPIO,0x0ff);
  /* Touch configuration - configure the resistance value to 1200 - this value is specific to customer requirement and derived by experiment */
  Ft_Gpu_Hal_Wr16(phost, REG_TOUCH_RZTHRESH,1200);



  /*It is optional to clear the screen here*/
  Ft_Gpu_Hal_WrMem(phost, RAM_DL,(ft_uint8_t *)FT_DLCODE_BOOTUP,sizeof(FT_DLCODE_BOOTUP));
  Ft_Gpu_Hal_Wr8(phost, REG_DLSWAP,DLSWAP_FRAME);

  //Ft_Gpu_Hal_Sleep(1000);//Show the booting up screen.


  pinMode(FT_SDCARD_CS,OUTPUT);
  digitalWrite(FT_SDCARD_CS,HIGH);
  delay(100);
  sd_present =  SD.begin(FT_SDCARD_CS);
  
  hal_rtc_i2c_init();
  byte WriteByte = 0x03;
  hal_rtc_i2c_write(0x07, &WriteByte,1);


  Info();
   if(sd_present)
  {
    FT_LiftApp_Portrait();   
  }
  else
  {
    Ft_Gpu_CoCmd_Dlstart(phost);    
    Ft_App_WrCoCmd_Buffer(phost,CLEAR(1,1,1));
    Ft_App_WrCoCmd_Buffer(phost,SCISSOR_XY(FT_DispWidth/12,FT_DispHeight/9));
    Ft_App_WrCoCmd_Buffer(phost,SCISSOR_SIZE(FT_DispWidth-2*(FT_DispWidth/12),FT_DispHeight-2*(FT_DispHeight/9)));
    Ft_App_WrCoCmd_Buffer(phost,CLEAR_COLOR_RGB(26,98,161));
    Ft_App_WrCoCmd_Buffer(phost,CLEAR(1,1,1));
    Ft_Gpu_CoCmd_Text(phost,FT_DispWidth/2,FT_DispHeight/2,28,OPT_CENTERX|OPT_CENTERY,"Storage Device not Found");
    Ft_App_WrCoCmd_Buffer(phost,DISPLAY());
    Ft_Gpu_CoCmd_Swap(phost);
    Ft_App_Flush_Co_Buffer(phost);
    Ft_Gpu_Hal_WaitCmdfifo_empty(phost);	
    delay(5000);       
  }
  
 
// Swissclock();
#ifdef MSVC_PLATFORM
  return 0;
#endif
}

void loop()
{
}



/* Nothing beyond this */



























